cdeck biock3
      subroutine biock3(data,ldata,datpnt,datchr,temp)
c
c   biock3 does actual check after calling biock2 to read one subfile
c
      real data(3,ldata),temp(*)
      double precision datchr(3,1)
      integer datpnt(1)
      include'maincomon.for'
      include'biocheckc.for'
c
c   l o c a l   v a r i a b l e s
c
   10 call biock2 (data,ldata,datpnt,datchr,ncase,nanim,nummis,temp)
      if (qfinf) return
      call dphead
c
c   display parameters to be used in check
c
      write (iolp,250) datchr(3,1),xmin(idic),ymin(idic),xmax(idic),ymax
     1 (idic),amph(idic),distm(idic)
      call linect (8)
c     check for empty input file
      if (ncase.le.0) go to 240
c   set up heading on errors listing by calling prdump with error=0
      call prdump (0,i,data(3,1),data(1,1),data(2,1))
      ianim=2
c     pddate = date of previous fix  gddate = date of last good fix
      gddate=data(3,1)*0.999999
      pddate=gddate
      px=data(1,1)
      py=data(2,1)
      do 230 i=1,ncase
      if (datpnt(ianim).gt.i) go to 20
      ianim=ianim+1
      j=1
      call prdump (j,i,data(3,i),data(1,i),data(2,i))
c     check date
   20 if (data(3,i)-pddate) 30,40,50
   30 j=2
      call prdump (j,i,data(3,i),data(1,i),data(2,i))
      go to 50
   40 j=3
      call prdump (j,i,data(3,i),data(1,i),data(2,i))
c   the following test is a dummy test for activity codes
   50 if (i.gt.0) go to 60
      j=4
      call prdump (j,i,data(3,i),data(1,i),data(2,i))
c     check for zeroed fix and negative coordinates
   60 if (data(1,i)) 80,130,70
   70 if (data(2,i)) 80,130,90
   80 j=7
      call prdump (j,i,data(3,i),data(1,i),data(2,i))
      go to 130
   90 if (xmin(idic)) 140,140,100
c     check to see if location is within specified range
  100 if ((data(1,i)-xmin(idic))*(xmax(idic)-data(1,i))) 120,120,110
  110 if ((data(2,i)-ymin(idic))*(ymax(idic)-data(2,i))) 120,120,140
  120 j=5
      call prdump (j,i,data(3,i),data(1,i),data(2,i))
c     store current date but not current location
  130 pddate=data(3,i)
      go to 230
  140 if (amph(idic).le.0.0.and.distm(idic).le.0.0) go to 220
      dist=sqrt((px-data(1,i))**2+(py-data(2,i))**2)
      if (distm(idic)) 190,190,150
c     distance check
  150 if (dist-distm(idic)*1000.) 190,190,160
  160 j=8
c     iflagd used to avoid erroneous error message for first distance co
      if (iflagd) 170,170,180
  170 iflagd=1
      go to 190
  180 call prdump (j,i,data(3,i),data(1,i),data(2,i))
  190 time=(data(3,i)-gddate)*24.0
      if (time) 220,220,200
  200 bmph=0.001*dist/time
c     rate check
      if (amph(idic)-bmph) 210,220,220
  210 j=6
      call prdump (j,i,data(3,i),data(1,i),data(2,i))
c     store current ddate and location
  220 gddate=data(3,i)
      pddate=gddate
      px=data(1,i)
      py=data(2,i)
  230 continue
      write (iolp,260) ncase,nummis
      call linect (3)
      go to 10
  240 write (iolp,270)
      go to 10
c
  250 format(//5x,'output from procedure biocheck for animal ',a8///
     1 10x,'utm xmin = ',g14.6,3x,'utm ymin = ',g14.6/
     2 10x,'utm xmax = ',g14.6,3x,'utm ymax = ',g14.6/
     3 10x,'speed limit = ',g14.6,' km/hr'/
     4 10x,'distance limit = ',g14.6,' km')
  260 format(/5x,'number of cases checked = ',i6/
     1        5x,'number of missing cases = ',i6)
  270 format(/5x,6h***** ,'error - no data on current input data file -
     1run aborted')
      end
