      program llutm
      character*25 line
      integer ladeg,lodeg
      real lamin,lomin
      double precision x,y,phi,lambda
 10   read(5,'(a25,i2,f5.0,1x,i3,f5.0)',end=30) line,ladeg,lamin,
     1   lodeg,lomin
      phi=float(ladeg)+lamin/60.
      lambda=float(lodeg)+lomin/60.
      lambda=-lambda
      call lltoutm(phi,lambda,x,y)
      write(6,'(1x,a25,i7,1x,i7)') line,int(x+0.5),int(y+0.5)
      go to 10
 30   stop
      end
      subroutine lamtoll(x,y,phi,lambda)
      implicit double precision (a-z)
      integer i
      a=6378206.4
      esq=0.00676866
      e=sqrt(esq)
      pi=atan(1.0)*4.0
      phi1=37.*pi/180.
      phi2=42.*pi/180.
      phi0=36.*pi/180.
      lambd0=-109*pi/180.
      xc=x-5000000.
      m1=cos(phi1)/sqrt(1.-esq*sin(phi1)**2)
      m2=cos(phi2)/sqrt(1.-esq*sin(phi2)**2)
      t0=tan(pi/4.-phi0/2.)/((1.-e*sin(phi0))/(1.+e*sin(phi0)))**(e/2.)
      t1=tan(pi/4.-phi1/2.)/((1.-e*sin(phi1))/(1.+e*sin(phi1)))**(e/2.)
      t2=tan(pi/4.-phi2/2.)/((1.-e*sin(phi2))/(1.+e*sin(phi2)))**(e/2.)
      n=(log(m1)-log(m2))/(log(t1)-log(t2))
      f=m1/(n*t1**n)
      rho0=a*f*t0**n
      rho=sqrt(xc**2+(rho0-y)**2)
      t=(rho/(a*f))**(1./n)
      theta=atan(xc/(rho0-y))
      lambda=theta/n+lambd0
      phi=pi/2-2*atan(t)
      do 10 i=1,80
      phic=pi/2-2*atan(t*((1-e*sin(phi))/(1+e*sin(phi)))**(e/2))
      if (phic/phi .lt. 1.0000001) go to 20
      phi=phic
 10   continue
 20   phi=phic
      phi=phi*180./pi
      lambda=lambda*180./pi
      return
      end
      subroutine lltoutm(phi,lambda,x,y)
      implicit double precision (a-z)
      a=6378206.4
      esq=0.00676866
      phi0=0
      lambd0=((int(-lambda/6.)*6)+3)*(-1)
      pi=atan(1.)*4.
      lambd0=lambd0*pi/180.
      k0=0.9996
      epsq=esq/(1-esq)
      phi=phi*pi/180.
      lambda=lambda*pi/180.
      n=a/sqrt(1.-esq*sin(phi)**2)
      t=tan(phi)**2
      c=epsq*cos(phi)**2
      biga=cos(phi)*(lambda-lambd0)
      m=111132.0894*phi*180./pi-16216.94*sin(2.*phi)+17.21*sin(4.*phi)-0
     1 .02*sin(6.*phi)
      m0=111132.0894*phi0*180./pi-16216.94*sin(2.*phi0)+17.21*sin(4.*phi
     1 0)-0.02*sin(6.*phi0)
      x=k0*n*(biga+(1.-t+c)*biga**3/6.+(5.-18.*t+t*t+72.*c-58.*epsq)*
     1  biga**5/120.)
      x=x+500000.
      y=k0*(m-m0+n*tan(phi)*(biga**2/2.+(5.-t+9.*c+4.*c**2)*biga**4/24.+
     1 (61.-58.*t+t**2+600.*c-330.*epsq)*biga**6/720.))
      return
      end
