title 'Logistic Regression of Piceance Mule Deer Fawns';
data fawns;
   infile 'fawns.dat';
   input treat $ 1-9 freq 11-17 sex $ 19-24
         weight 26-29 length 31-35 time 37-39;
   if time ^= . then status='Lived';
   else status='Died';
   label treat='Treatment or Control area'
         freq='Individual id -- radio frequency'
         sex='Sex of fawn'
         weight='Weight in kg'
         length='Length in cm'
         time='Days until death'
         status='Lived or Died';
proc catmod;
   direct weight length;
   model status=treat sex weight length / ml nogls;
run;
