c   common block for biocheck procedure
c
      common /biochkc/ xmin(200),ymin(200),xmax(200),ymax(200),
     1      amph(200),distm(200),iact(200),maxaim,maxcase,
     2      nagelab,nsexlab,qfing,qfinf
      common /biochks/ varlab(5,6),agelab(6,10),sexlab(6,3)
      real xmin,ymin,xmax,ymax,amph,distm
      character*8 varlab,agelab,sexlab
      integer iact,maxaim,maxcase,nagelab,nsexlab
      logical   qfing,qfinf
c
c   variable definitions in biochkc
c
c   xmin      - minimum x coordinate (utm assumed)
c   ymin      - minimum y coordinate (utm assumed)
c   xmax      - maximum x coordinate (utm assumed)
c   ymax      - maximum y coordinate (utm assumed)
c   amph      - greatest rate of movement allowed (km/hr)
c   distm     - maximum distance allowed between two
c                 consecutive fixes (km)
c   iact      - check for missing active code
c     varlab       - variable labels for each entry in varnum
c     agelab       - value labels for age variable to be used in labels
c     nagelab      - number of entries in agelab
c     sexlab       - value labels for sex variable to be used in labels
c     nsexlab      - number of entries in sexlab
c     maxaim       - maximum number of animals that are dimensioned
c                    (can be adjusted in the procedure call)
c     maxcase      - maximum number of cases that are dimensioned
c                    (can be adjusted in the procedure call)
c
