cdeck biock5
      subroutine biock5(x,xchar,idig)
c
c   x     - floating point number
c   xchar - left justified character representation of x
c   idig  - number of digits to right of decimal
c           if idig .ge. 10 then x set to xchar
c           if idig .eq. 0 then integer format with no decimal used
c
      double precision x,xchar
      integer*2 idig
      character quote*1,xstr*8,xstr2*8
c
      if (idig.ge.10) then
c         x is already in character format
c         therefore check for quotes to be removed
         write(xstr,'(a8)') x
         do 10 i=1,2
            if (i.eq.1) then
               quote=''''
            elseif (i.eq.2) then
               quote='"'
            endif
            i1=index(xstr,quote)
            if (i1.gt.0) then
               i2=index(xstr(i1+1:8),quote)+i1
               if (i2.gt.i1+1) then
                  xstr2=xstr(i1+1:i2-1)
                  xstr=xstr2
               endif
            endif
 10         continue
      elseif (idig.eq.0) then
         write(xstr,'(i8)') int(x+0.5)
      else
         write(xstr2,'(''(f8.'',i1,'')'')') min(idig,7)
         write(xstr,xstr2) x
      endif
c   xstr now contains the character representation of x
c   remove leading blanks
      do 20 i=1,len(xstr)
         if (xstr(i:i).ne.' ') go to 30
 20      continue
      i=1
 30   xstr2=xstr(i:len(xstr))
      xstr=xstr2
c   put xstr into xchar
      read(xstr,'(a8)') xchar
      return
      end
