:begin
REM
REM      Check that user has specified an animal to plot
REM
if "%1" == "" goto quit
REM
REM      Pick out fixes for animal specified in argument list
REM          and create HOMER input file
REM
grep "%1" <fixes.dat >homer.dat
rem
REM      Execute HOMER to compute home range estimates and generate
REM        HOMER.LOC -- containing locations
REM        HOMER.ELP -- containing 200 perimeter points for JT ellipse
REM        HOMER.ELU -- containing 200 perimeter points for JT ellipse
REM                     constructed from just the unique data
REM        HOMER.DUN -- containing 200 perimeter points for Dunn ellipse
REM        HOMER.CON -- containing the vertices of convex polygon
rem
key-fake "xcoor=3 ycoor=4 time=1 id=2 dunntime=45 minutes"13"lotus ( jt polygon dunn data )"13 26 13
homer
REM
REM     Remove homer data file and temporary file
REM
REM del homer.dat
del iobcd2.tmp
del plot.pic
REM
REM  Branch to Lotus directory to plot data
REM
cd \123
rem
REM     Send string of Lotus commands to Lotus via KEY-FAKE to build
REM            three graphs of Locations, Ellipse and Polygon and
REM            exit Lotus.  The PLOT.WK1 spreadsheet does the work.
rem
key-fake 0 13"/frplot"13
123
REM      Return to telemetry directory
cd \biotlm\homer
REM
REM      Clean up directory -- delete lotus input files
REM
REM del homer.loc
REM del homer.con
REM del homer.elp
REM
REM      Branch to Freelance directory
cd\fl
rem
REM      Now in FreeLance, suck in three graphs just made by Lotus,
REM             overlay them and be prepared to add study area
REM              overlay as well as any notation to be made.
rem
key-fake 13 13 "ofpfc:\book\figures\chap.07"13"ofpoc:\biotlm\homer"13"fipplot"13
fl
REM
REM      Prepare to plot the next animal
shift
cd\biotlm\homer
goto begin
:quit
