c   common block for home range estimation
c
      common /homerc/ xco(200),yco(200),siz(200),nint(200),
     1      time(200),smini(200),tobig(200),ndon(200),
     2      duntim(200),dunprt,nsum,nomap,irem,maxcase,pi
      integer nint,ndon,nsum,nomap,irem,maxcase,dunprt
      real xco,yco,siz,time,smini,tobig,duntim,pi
      common /homstr/ varlab
      character*8 varlab(5,3)
c
c   variable  - contents
c
c   varnum(1) - variable number for x coordinate (in meters)
c   varnum(2) - variable number for y coordinate (in meters)
c   varnum(3) - variable number for time (days)
c   xco(i)    - smallest x value in meters from the origin in meters
c               for subfile i
c   yco(i)    - smallest y value in meters from the origin in meters
c               for subfile i
c   siz(i)    - size of a grid square in meters for subfile i
c   nint(i)   - number of grid intervals for subfile i
c   time(i)   - maximum time differiential for which fixes will be
c               added for vector fill (days)
c   smini(i)  - increment in meters for vector fill for subfile i
c   tobig(i)  - maximum distance in meters for vector fill for subfile i
c   ndon(i)   - maximum number of grids to fill between real fixes
c               for subfile i
c   varlab    - variable labels for x coordinate, y coordinate, and time
c   nsum      - print option (0=no map printed)
c                            (1=print map with fixes only)
c                            (2=print map with both fixes and fill)
c                            (3=print map both ways)
c   nomap     - y grid cell siz is changed for map overlay option
c   irem      - wild fix removal option (0=no removal, 1=removal)
c   maxcase   - maximum number of cases expected for data
c               (dynamic storage allocation can override the value)
c   dunprt    - print options flag for dunn estimator
c   duntim    - time interval between locations within a burst for dunn
c               estimator
c
c         *  *  *   l o c a l   v a r i a b l e s   *  *  *
c
