data inside;
   array xcoor{100};
   array ycoor{100};
   drop seed i npoly iii jjj f;
   xcoor{1}=1;   ycoor{1}=1;
   xcoor{2}=0.5; ycoor{2}=1.5;
   xcoor{3}=1;   ycoor{3}=2;
   xcoor{4}=1.5; ycoor{4}=2.5;
   xcoor{5}=2;   ycoor{5}=2;
   xcoor{6}=2.5; ycoor{6}=1.5;
   xcoor{7}=2;   ycoor{7}=1;
   xcoor{8}=1.5; ycoor{8}=0.5;
   npoly=8;
   plotsym='+'; do i=1 to npoly; x=xcoor{i}; y=ycoor{i}; output; end;
   seed=9955447;
   do i=1 to 100;
      x=ranuni(seed)*3;
      y=ranuni(seed)*3;
      link inside;
      if in then plotsym='I'; else plotsym='O';
      output;
      end;
   return;
*--------------------------------------------------------------*
|     This subroutine determines whether a point lies          |
|     inside or outside of a polygon (regular or irregular,    |
|     including concave and re-entrant).                       |
|     Written by Melvin L. Prueitt.  Version Aug. 25,1980.     |
|  npoly -  Number of vertices of the polygon.                 |
|  x     -  x coordinate of the point in question.             |
|  y     -  y coordinate of the point in question.             |
|  xcoor, ycoor are arrays giving the coordinates of the       |
|           polygon vertices.                                  |
|  in    - returned to the caller as a 1 if the point (x,y)    |
|          is inside the polygon, 0 if outside.  points on the |
|          boundary are considered to be outisde, but rounding |
|          errors sometimes cause boundary points to be inside.|
*--------------------------------------------------------------*;
inside: in=0;
      iii = npoly;
 s100:f = ycoor{1}-ycoor{iii};
      if f = 0 then do;
         iii = iii-1;
         if iii >= 1 then goto s100;
         else goto s600;
         end;
      else
        do iii=1 to npoly;
           jjj = mod(iii,npoly)+1;
           if (y-ycoor{iii})*(y-ycoor{jjj}) > 0 then goto s500;
           if y = ycoor{jjj} then goto s500;
           if y ^= ycoor{iii} then goto s400;
           if f*(ycoor{jjj}-y) > 0 then goto s500;
s400:      if x > (y-ycoor{iii})*(xcoor{jjj}-xcoor{iii})/
              (ycoor{jjj}-ycoor{iii})+xcoor{iii} then in = 1 - in;
s500:      if ycoor{jjj} ^= ycoor{iii} then f = ycoor{jjj}-ycoor{iii};
           end;
s600: return;
proc print;
proc plot; plot y*x=plotsym;
run;
