5 'Version of 1 Apr 84
10 DEFINT I-N
14 ' NT is the number of towers on the study area
15 NT=8
16 ' IU is the number of towers currently being used
17 IU=3
20 DIM AZ(IU),UTM(2,NT),IT(IU),A(2,2),B(2)
30 PI=ATN(1.)*4.
40 INPUT "Azimuth Standard Deviation";CP
44 'Convert azimuth standard deviation to kappa
45 CP=EXP((CP*PI/180.)^2*(-0.5))
46 CP=1./(2.*(1.-CP)+(1.-CP)^2*(.48794-.82905*CP-1.3915*CP^2)/CP)
49 'Modify this statement for changes in IU
50 INPUT "Tower numbers";IT(1),IT(2),IT(3)
60 OPEN "ram:towers.do" FOR INPUT AS 1
70 FOR I=1 TO NT
80 INPUT #1,UTM(1,I),UTM(2,I)
90 NEXT I
100 CLOSE 1
111 XX=UTM(1,IT(1))
112 XN=XX
113 YX=UTM(2,IT(1))
114 YN=YX
115 FOR I=2 TO IU
116 IF XX < UTM(1,IT(I)) THEN XX=UTM(1,IT(I))
117 IF XN > UTM(1,IT(I)) THEN XN=UTM(1,IT(I))
118 IF YX < UTM(2,IT(I)) THEN YX=UTM(2,IT(I))
119 IF YN > UTM(2,IT(I)) THEN YN=UTM(2,IT(I))
121 NEXT I
125 BD=XX-XN
126 IF BD < (YX-YN) THEN BD=YX-YN
127 BD=0.15*BD 'BD is set to a 15% border
130 XX=XX+BD
131 XN=XN-BD
132 YX=YX+BD
133 YN=YN-BD
134 YC=63/(YX-YN)
135 XC=63/(XX-XN)
136 IF YC > XC THEN YC=XC
137 IF XC > YC THEN XC=YC
200 CLS:OPEN "ram:azimth" FOR APPEND AS 1
210 ON ERROR GOTO 300
299 'Modify this statement for changes in IU
300 CLS:INPUT "Animal id & 3 azimuths";ID$,AZ(1),AZ(2),AZ(3)
330 IF ID$ = "end" THEN GOTO 3000
340 IF ID$ = "END" THEN GOTO 3000
349 'Modify this statement for changes in IU
350 PRINT #1,USING "\        \ \        \ \    \ # ### # ### # ###";DATE$;TIME$;ID$;IT(1);AZ(1);IT(2);AZ(2);IT(3);AZ(3)
360 GOSUB 500
370 GOTO 300
499 'Code to summarize azimuths and plot
500 CLS:PRINT "Id is ";ID$
501 'Modify this statement for changes in IU
502 PRINT "Azimuths ";AZ(1);AZ(2);AZ(3)
510 LINE (160,0)-(160,63)
511 LINE (159,0)-(159,63)
520 FOR I=1 TO IU
530 X=UTM(1,IT(I))
540 Y=UTM(2,IT(I))
550 GOSUB 1000
560 XE=X:YE=Y
570 R=XX-XN
580 IF YX-YN > R THEN R=YX-YN
585 AZ(I)=(90.-AZ(I))*(PI/180)
590 R=R-0.1*(XX-XN)
600 X=R*COS(AZ(I))+UTM(1,IT(I))
610 Y=R*SIN(AZ(I))+UTM(2,IT(I))
615 X=INT((X-XN)*XC)+175
616 Y=INT((YX-Y)*YC)
620 IF X < 160 THEN GOTO 590
630 IF Y < 0 THEN GOTO 590
640 IF X > 239 THEN GOTO 590
650 IF Y > 63 THEN GOTO 590
680 LINE(XE,YE)-(X,Y)
770 NEXT I
771 GOSUB 2000
772 PRINT "Location:"
773 PRINT "x=";XL
774 PRINT "y=";YL
776 PRINT "Confidence ellipse (ha)"
777 PRINT;EA
779 INPUT "Next";I
780 ON ERROR GOTO 300
781 RETURN
1000 X=INT((X-XN)*XC+175)
1010 Y=INT((YX-Y)*YC)
1020 LINE(X-1,Y-1)-(X+1,Y+1),1,BF
1030 RETURN
2000 ON ERROR GOTO 779
2005 NI=0
2009 'Obtain initial estimate
2010 XL=0.:YL=0.
2015 FOR I=1 TO IU
2020 XL=XL+UTM(1,IT(I))
2025 YL=YL+UTM(2,IT(I))
2030 NEXT I
2035 XL=XL/IU:YL=YL/IU
2050 CV$="f"
2060 IN$="t"
2070 FOR I=1 TO 2
2080 B(I)=0.
2090 FOR J=1 TO 2
2100 A(I,J)=0.
2110 NEXT J
2120 NEXT I
2130 FOR I=1 TO IU
2140 SI=SIN(AZ(I))
2150 CI=COS(AZ(I))
2160 ZI=SI*UTM(1,IT(I))-CI*UTM(2,IT(I))
2170 IF IN$ = "f" THEN GOTO 2200
2180 SS=SI
2190 CS=CI
2195 GOTO 2230
2200 DI=SQR((XL-UTM(1,IT(I)))^2+(YL-UTM(2,IT(I)))^2)
2210 SS=(YL-UTM(2,IT(I)))/(DI^3)
2220 CS=(XL-UTM(1,IT(I)))/(DI^3)
2230 A(1,1)=A(1,1)+SI*SS
2240 A(2,2)=A(2,2)+CI*CS
2250 A(1,2)=A(1,2)-CI*SS
2260 A(2,1)=A(2,1)-SI*CS
2270 B(1)=B(1)+SS*ZI
2280 B(2)=B(2)-CS*ZI
2290 NEXT I
2300 YM=(A(1,1)*B(2)-A(2,1)*B(1))/(A(1,1)*A(2,2)-A(2,1)*A(1,2))
2310 XM=(B(1)-A(1,2)*YM)/A(1,1)
2315 IN$="f"
2320 IF ABS(XM-XL)/XM < 0.00001 AND ABS(YM-YL)/YM < 0.00001 THEN CV$="t"
2330 XL=XM:YL=YM
2340 NI=NI+1
2350 IF CV$ = "f" AND NI < 20 THEN 2070
2360 'Convergence achieved - get vc mat
2365 ON ERROR GOTO 772
2367 V1=0.:V2=0.:V3=0.
2370 FOR I=1 TO IU
2380 SI=SIN(AZ(I))
2390 CI=COS(AZ(I))
2400 DI=SQR((XL-UTM(1,IT(I)))^2+(YL-UTM(2,IT(I)))^2)
2410 CS=(XL-UTM(1,IT(I)))/(DI^3)
2420 SS=(YL-UTM(2,IT(I)))/(DI^3)
2430 V1=V1+SI*SS
2440 V2=V2+CI*SS+SI*CS
2450 V3=V3+CI*CS
2460 NEXT I
2470 V2=V2*(-0.5)
2490 DI=1./((V1*V3-V2^2)*CP^2)
2500 EA=0.0001*PI*5.99*SQR(DI)
2505 ON ERROR GOTO 300
2510 RETURN
3000 CLS
3010 PRINT "Available memory allows";INT(FRE(0)/(29+IU*6))
3011 PRINT "locations to be stored before"
3012 PRINT "dumping file 'azimth.do' to tape"
3013 PRINT "or to another computer."
3030 END
